# MFS_SuperLister.T: find a pattern of text, even if it spans several
#lines. List all instances in the format "fileName startingLine"
#
########### THIS IS NOT AN EXECUTABLE PROGRAM ############
#
#the program to run for "superlisting" is called $MFS_SuperLister.
#This is the "Template" from which the Actual lister program
#(MFS_SuperLister.A) is produced by $MFS_SuperLister. In the line
#	while (match(multi, find) > 0)
#"find" is replaced by the actual find string. This produces a program
#with static rather than dynamic regular expression to search for,
#and it runs faster as a result.

BEGIN {		
			if (ignorecase != 0)
				IGNORECASE = 1;
			progressFile = STDPATH "$tempProgress"
		}

#Extract file name proper from end of full path name
FNR == 1 {	z = split(FILENAME, names, ":")
			if (!progress("\nSearching " names[z]))
				{ # concurrent mode, print progress to file
				print "Searching", names[z], "..." > progressFile
				close(progressFile)
				}
			}

#Roll all lines from the file through a queue, "multi". A "\n" between
#the lines in multi restores the "\n" that was trimmed by "getline".
#The size of multi must be limited to avoid overflow, so no more lines
#are kept than there are words in the "find" pattern. Note "getline x"
#sets FNR, so no need to keep track of the line number separately.
	{multi = $0;#the first line is already there
	while (getline x > 0)#== 0 at end of file, < 0 for error
		{
		multi = multi "\n" x;
		while (match(multi, find) > 0) ##MARK find
			{
			print names[z], FNR
			++num
			multi = substr(multi, RSTART + RLENGTH);#trim the matched prefix
			}
		numLines = gsub(/\n/, "\n", multi) + 1;
		if (numLines > maxLines)##MARK maxLines
			{
			while (numLines > maxLines)##MARK maxLines
				{
				j = index(multi, "\n");
				if (j < length(multi))
					multi = substr(multi, j + 1);
				else
					multi = "";
				--numLines;
				}
			}
		}
	}

END		{ 	if (num > 0)
				print num, "matches total"
			else
				print "no matches"
			}
